Index: uspace/lib/gfx/include/gfx/cursor.h
===================================================================
--- uspace/lib/gfx/include/gfx/cursor.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/gfx/include/gfx/cursor.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfx
+ * @{
+ */
+/**
+ * @file Hardware cursor control
+ */
+
+#ifndef _GFX_CURSOR_H
+#define _GFX_CURSOR_H
+
+#include <errno.h>
+#include <types/gfx/coord.h>
+#include <types/gfx/context.h>
+#include <stdbool.h>
+
+extern errno_t gfx_cursor_get_pos(gfx_context_t *, gfx_coord2_t *);
+extern errno_t gfx_cursor_set_pos(gfx_context_t *, gfx_coord2_t *);
+extern errno_t gfx_cursor_set_visible(gfx_context_t *, bool);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfx/include/gfx/render.h
===================================================================
--- uspace/lib/gfx/include/gfx/render.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfx/include/gfx/render.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,6 +42,8 @@
 #include <types/gfx/context.h>
 
+extern errno_t gfx_set_clip_rect(gfx_context_t *, gfx_rect_t *);
 extern errno_t gfx_set_color(gfx_context_t *, gfx_color_t *);
 extern errno_t gfx_fill_rect(gfx_context_t *, gfx_rect_t *);
+extern errno_t gfx_update(gfx_context_t *);
 
 #endif
Index: uspace/lib/gfx/include/types/gfx/ops/context.h
===================================================================
--- uspace/lib/gfx/include/types/gfx/ops/context.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfx/include/types/gfx/ops/context.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -44,11 +44,16 @@
 #include <types/gfx/coord.h>
 #include <types/gfx/context.h>
+#include <stdbool.h>
 
 /** Graphics context ops */
 typedef struct {
+	/** Set clipping rectangle */
+	errno_t (*set_clip_rect)(void *, gfx_rect_t *);
 	/** Set drawing color */
 	errno_t (*set_color)(void *, gfx_color_t *);
 	/** Fill rectangle using the current drawing color */
 	errno_t (*fill_rect)(void *, gfx_rect_t *);
+	/** Update display */
+	errno_t (*update)(void *);
 	/** Create bitmap */
 	errno_t (*bitmap_create)(void *, gfx_bitmap_params_t *,
@@ -60,4 +65,10 @@
 	/** Get bitmap allocation info */
 	errno_t (*bitmap_get_alloc)(void *, gfx_bitmap_alloc_t *);
+	/** Get hardware cursor position */
+	errno_t (*cursor_get_pos)(void *, gfx_coord2_t *);
+	/** Set hardware cursor position */
+	errno_t (*cursor_set_pos)(void *, gfx_coord2_t *);
+	/** Set hardware cursor visibility */
+	errno_t (*cursor_set_visible)(void *, bool);
 } gfx_context_ops_t;
 
Index: uspace/lib/gfx/meson.build
===================================================================
--- uspace/lib/gfx/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfx/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2019 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -32,4 +32,5 @@
 	'src/coord.c',
 	'src/context.c',
+	'src/cursor.c',
 	'src/render.c'
 )
@@ -39,4 +40,5 @@
 	'test/color.c',
 	'test/coord.c',
+	'test/cursor.c',
 	'test/main.c',
 	'test/render.c',
Index: uspace/lib/gfx/src/cursor.c
===================================================================
--- uspace/lib/gfx/src/cursor.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/gfx/src/cursor.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,93 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfx
+ * @{
+ */
+/**
+ * @file Hardware cursor control
+ */
+
+#include <errno.h>
+#include <gfx/context.h>
+#include <gfx/coord.h>
+#include <gfx/cursor.h>
+#include <gfx/render.h>
+#include <stdbool.h>
+#include "../private/context.h"
+
+/** Get hardware cursor position.
+ *
+ * @param gc Graphic context
+ * @param pos Place to store cursor position
+ *
+ * @return EOK on success, ENOTSUP if not supported,
+ *         EIO if grahic device connection was lost
+ */
+errno_t gfx_cursor_get_pos(gfx_context_t *gc, gfx_coord2_t *pos)
+{
+	if (gc->ops->cursor_get_pos != NULL)
+		return gc->ops->cursor_get_pos(gc->arg, pos);
+	else
+		return ENOTSUP;
+}
+
+/** Set hardware cursor position.
+ *
+ * @param gc Graphic context
+ * @param pos New cursor position
+ *
+ * @return EOK on success, ENOTSUP if not supported,
+ *         EIO if grahic device connection was lost
+ */
+errno_t gfx_cursor_set_pos(gfx_context_t *gc, gfx_coord2_t *pos)
+{
+	if (gc->ops->cursor_set_pos != NULL)
+		return gc->ops->cursor_set_pos(gc->arg, pos);
+	else
+		return ENOTSUP;
+}
+
+/** Set hardware cursor visibility.
+ *
+ * @param gc Graphic context
+ * @param visible @c true iff cursor should be made visible
+ *
+ * @return EOK on success, ENOTSUP if not supported,
+ *         EIO if grahic device connection was lost
+ */
+errno_t gfx_cursor_set_visible(gfx_context_t *gc, bool visible)
+{
+	if (gc->ops->cursor_set_visible != NULL)
+		return gc->ops->cursor_set_visible(gc->arg, visible);
+	else
+		return ENOTSUP;
+}
+
+/** @}
+ */
Index: uspace/lib/gfx/src/render.c
===================================================================
--- uspace/lib/gfx/src/render.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfx/src/render.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,4 +37,17 @@
 #include "../private/context.h"
 
+/** Set clipping rectangle.
+ *
+ * @param gc Graphic context
+ * @param rect Rectangle or @c NULL (no extra clipping)
+ *
+ * @return EOK on success, ENOMEM if insufficient resources,
+ *         EIO if grahic device connection was lost
+ */
+errno_t gfx_set_clip_rect(gfx_context_t *gc, gfx_rect_t *rect)
+{
+	return gc->ops->set_clip_rect(gc->arg, rect);
+}
+
 /** Set drawing color.
  *
@@ -63,4 +76,18 @@
 }
 
+/** Update display.
+ *
+ * Finish any deferred rendering.
+ *
+ * @param gc Graphic context
+ *
+ * @return EOK on success, ENOMEM if insufficient resources,
+ *         EIO if grahic device connection was lost
+ */
+errno_t gfx_update(gfx_context_t *gc)
+{
+	return gc->ops->update(gc->arg);
+}
+
 /** @}
  */
Index: uspace/lib/gfx/test/cursor.c
===================================================================
--- uspace/lib/gfx/test/cursor.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/gfx/test/cursor.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,265 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/context.h>
+#include <gfx/cursor.h>
+#include <pcut/pcut.h>
+#include <mem.h>
+#include <stdbool.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(cursor);
+
+static errno_t testgc_cursor_get_pos(void *, gfx_coord2_t *);
+static errno_t testgc_cursor_set_pos(void *, gfx_coord2_t *);
+static errno_t testgc_cursor_set_visible(void *, bool);
+
+static gfx_context_ops_t ops = {
+	.cursor_get_pos = testgc_cursor_get_pos,
+	.cursor_set_pos = testgc_cursor_set_pos,
+	.cursor_set_visible = testgc_cursor_set_visible
+};
+
+/** Test graphics context data */
+typedef struct {
+	errno_t rc;
+
+	bool cursor_get_pos;
+	gfx_coord2_t get_pos_pos;
+
+	bool cursor_set_pos;
+	gfx_coord2_t set_pos_pos;
+
+	bool cursor_set_visible;
+	bool set_visible_vis;
+} test_gc_t;
+
+/** Get hardware cursor position with error return */
+PCUT_TEST(cursor_get_pos_failure)
+{
+	errno_t rc;
+	gfx_coord2_t pos;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EIO;
+
+	rc = gfx_cursor_get_pos(gc, &pos);
+	PCUT_ASSERT_ERRNO_VAL(tgc.rc, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_get_pos);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Get hardware cursor position */
+PCUT_TEST(cursor_get_pos_success)
+{
+	errno_t rc;
+	gfx_coord2_t pos;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EOK;
+	tgc.get_pos_pos.x = 1;
+	tgc.get_pos_pos.y = 2;
+
+	rc = gfx_cursor_get_pos(gc, &pos);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_get_pos);
+	PCUT_ASSERT_INT_EQUALS(tgc.get_pos_pos.x, pos.x);
+	PCUT_ASSERT_INT_EQUALS(tgc.get_pos_pos.y, pos.y);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set hardware cursor position with error return */
+PCUT_TEST(cursor_set_pos_failure)
+{
+	errno_t rc;
+	gfx_coord2_t pos;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EIO;
+	pos.x = 1;
+	pos.y = 2;
+
+	rc = gfx_cursor_set_pos(gc, &pos);
+	PCUT_ASSERT_ERRNO_VAL(tgc.rc, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_set_pos);
+	PCUT_ASSERT_INT_EQUALS(pos.x, tgc.set_pos_pos.x);
+	PCUT_ASSERT_INT_EQUALS(pos.y, tgc.set_pos_pos.y);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set hardware cursor position */
+PCUT_TEST(cursor_set_pos_success)
+{
+	errno_t rc;
+	gfx_coord2_t pos;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EOK;
+	pos.x = 1;
+	pos.y = 2;
+
+	rc = gfx_cursor_set_pos(gc, &pos);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_set_pos);
+	PCUT_ASSERT_INT_EQUALS(pos.x, tgc.set_pos_pos.x);
+	PCUT_ASSERT_INT_EQUALS(pos.y, tgc.set_pos_pos.y);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set hardware cursor visibility with error return */
+PCUT_TEST(cursor_set_visible_failure)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EIO;
+
+	rc = gfx_cursor_set_visible(gc, true);
+	PCUT_ASSERT_ERRNO_VAL(tgc.rc, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_set_visible);
+	PCUT_ASSERT_TRUE(tgc.set_visible_vis);
+
+	tgc.cursor_set_visible = false;
+
+	rc = gfx_cursor_set_visible(gc, false);
+	PCUT_ASSERT_ERRNO_VAL(tgc.rc, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_set_visible);
+	PCUT_ASSERT_FALSE(tgc.set_visible_vis);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set hardware cursor visibility */
+PCUT_TEST(cursor_set_visible_success)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EOK;
+
+	rc = gfx_cursor_set_visible(gc, true);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_set_visible);
+	PCUT_ASSERT_TRUE(tgc.set_visible_vis);
+
+	tgc.cursor_set_visible = false;
+
+	rc = gfx_cursor_set_visible(gc, false);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.cursor_set_visible);
+	PCUT_ASSERT_FALSE(tgc.set_visible_vis);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+static errno_t testgc_cursor_get_pos(void *arg, gfx_coord2_t *pos)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+
+	tgc->cursor_get_pos = true;
+	*pos = tgc->get_pos_pos;
+
+	return tgc->rc;
+}
+
+static errno_t testgc_cursor_set_pos(void *arg, gfx_coord2_t *pos)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+
+	tgc->cursor_set_pos = true;
+	tgc->set_pos_pos = *pos;
+
+	return tgc->rc;
+}
+
+static errno_t testgc_cursor_set_visible(void *arg, bool visible)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+
+	tgc->cursor_set_visible = true;
+	tgc->set_visible_vis = visible;
+
+	return tgc->rc;
+}
+
+PCUT_EXPORT(cursor);
Index: uspace/lib/gfx/test/main.c
===================================================================
--- uspace/lib/gfx/test/main.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfx/test/main.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2017 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,4 +34,5 @@
 PCUT_IMPORT(color);
 PCUT_IMPORT(coord);
+PCUT_IMPORT(cursor);
 PCUT_IMPORT(render);
 
Index: uspace/lib/gfx/test/render.c
===================================================================
--- uspace/lib/gfx/test/render.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfx/test/render.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -32,4 +32,5 @@
 #include <pcut/pcut.h>
 #include <mem.h>
+#include <stdbool.h>
 
 PCUT_INIT;
@@ -37,18 +38,114 @@
 PCUT_TEST_SUITE(render);
 
+static errno_t testgc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t testgc_set_color(void *, gfx_color_t *);
 static errno_t testgc_fill_rect(void *, gfx_rect_t *);
+static errno_t testgc_update(void *);
 
 static gfx_context_ops_t ops = {
+	.set_clip_rect = testgc_set_clip_rect,
 	.set_color = testgc_set_color,
-	.fill_rect = testgc_fill_rect
+	.fill_rect = testgc_fill_rect,
+	.update = testgc_update
 };
 
 /** Test graphics context data */
 typedef struct {
+	errno_t rc;
+
+	bool set_clip_rect;
+	gfx_rect_t crect;
+	bool do_clip;
+
+	bool set_color;
 	gfx_color_t *dclr;
-	gfx_rect_t *rect;
+
+	bool fill_rect;
+	gfx_rect_t frect;
+
+	bool update;
 } test_gc_t;
 
+/** Set clipping rectangle */
+PCUT_TEST(set_clip_rect)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 1;
+	rect.p0.y = 2;
+	rect.p1.x = 3;
+	rect.p1.y = 4;
+
+	tgc.rc = EOK;
+
+	rc = gfx_set_clip_rect(gc, &rect);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.set_clip_rect);
+	PCUT_ASSERT_TRUE(tgc.do_clip);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.x, tgc.crect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.y, tgc.crect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.x, tgc.crect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.y, tgc.crect.p1.y);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set null clipping rectangle */
+PCUT_TEST(set_clip_rect_null)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EOK;
+
+	rc = gfx_set_clip_rect(gc, NULL);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.set_clip_rect);
+	PCUT_ASSERT_FALSE(tgc.do_clip);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set clipping rectangle with error return */
+PCUT_TEST(set_clip_rect_failure)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EIO;
+
+	rc = gfx_set_clip_rect(gc, &rect);
+	PCUT_ASSERT_ERRNO_VAL(EIO, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set drawing color */
 PCUT_TEST(set_color)
 {
@@ -56,4 +153,5 @@
 	gfx_color_t *color;
 	gfx_context_t *gc = NULL;
+	uint16_t r, g, b;
 	test_gc_t tgc;
 
@@ -66,8 +164,45 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
+	PCUT_ASSERT_FALSE(tgc.set_color);
+
+	tgc.rc = EOK;
+
 	rc = gfx_set_color(gc, color);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_EQUALS(color, tgc.dclr);
-	PCUT_ASSERT_NULL(tgc.rect);
+
+	PCUT_ASSERT_TRUE(tgc.set_color);
+
+	gfx_color_get_rgb_i16(tgc.dclr, &r, &g, &b);
+
+	PCUT_ASSERT_INT_EQUALS(0xffff, r);
+	PCUT_ASSERT_INT_EQUALS(0xffff, g);
+	PCUT_ASSERT_INT_EQUALS(0xffff, b);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Set drawing color with error return */
+PCUT_TEST(set_color_failure)
+{
+	errno_t rc;
+	gfx_color_t *color;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(tgc.set_color);
+
+	tgc.rc = EIO;
+
+	rc = gfx_set_color(gc, color);
+	PCUT_ASSERT_ERRNO_VAL(EIO, rc);
 
 	gfx_color_delete(color);
@@ -77,8 +212,8 @@
 }
 
+/** Fill rectangle */
 PCUT_TEST(fill_rect)
 {
 	errno_t rc;
-	gfx_color_t *color;
 	gfx_rect_t rect;
 	gfx_context_t *gc = NULL;
@@ -90,19 +225,112 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = gfx_set_color(gc, color);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_EQUALS(color, tgc.dclr);
+	rect.p0.x = 1;
+	rect.p0.y = 2;
+	rect.p1.x = 3;
+	rect.p1.y = 4;
+
+	PCUT_ASSERT_FALSE(tgc.fill_rect);
+
+	tgc.rc = EOK;
 
 	rc = gfx_fill_rect(gc, &rect);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_EQUALS(&rect, tgc.rect);
-
-	gfx_color_delete(color);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(tgc.fill_rect);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.x, tgc.frect.p0.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p0.y, tgc.frect.p0.y);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.x, tgc.frect.p1.x);
+	PCUT_ASSERT_INT_EQUALS(rect.p1.y, tgc.frect.p1.y);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Fill rectangle with error return */
+PCUT_TEST(fill_rect_failure)
+{
+	errno_t rc;
+	gfx_rect_t rect;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rect.p0.x = 1;
+	rect.p0.y = 2;
+	rect.p1.x = 3;
+	rect.p1.y = 4;
+
+	PCUT_ASSERT_FALSE(tgc.fill_rect);
+
+	tgc.rc = EIO;
+
+	rc = gfx_fill_rect(gc, &rect);
+	PCUT_ASSERT_ERRNO_VAL(EIO, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Update GC */
+PCUT_TEST(update)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EOK;
+
+	PCUT_ASSERT_FALSE(tgc.update);
+	rc = gfx_update(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_TRUE(tgc.update);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** Update GC with error return */
+PCUT_TEST(update_failure)
+{
+	errno_t rc;
+	gfx_context_t *gc = NULL;
+	test_gc_t tgc;
+
+	memset(&tgc, 0, sizeof(tgc));
+
+	rc = gfx_context_new(&ops, &tgc, &gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tgc.rc = EIO;
+	rc = gfx_update(gc);
+
+	PCUT_ASSERT_ERRNO_VAL(EIO, rc);
+
+	rc = gfx_context_delete(gc);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+static errno_t testgc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+
+	tgc->set_clip_rect = true;
+	if (rect != NULL) {
+		tgc->do_clip = true;
+		tgc->crect = *rect;
+	} else {
+		tgc->do_clip = false;
+	}
+
+	return tgc->rc;
 }
 
@@ -110,8 +338,10 @@
 {
 	test_gc_t *tgc = (test_gc_t *) arg;
+
+	tgc->set_color = true;
 
 	/* Technically we should copy the data */
 	tgc->dclr = color;
-	return EOK;
+	return tgc->rc;
 }
 
@@ -120,7 +350,15 @@
 	test_gc_t *tgc = (test_gc_t *) arg;
 
-	/* Technically we should copy the data */
-	tgc->rect = rect;
-	return EOK;
+	tgc->fill_rect = true;
+	tgc->frect = *rect;
+	return tgc->rc;
+}
+
+static errno_t testgc_update(void *arg)
+{
+	test_gc_t *tgc = (test_gc_t *) arg;
+
+	tgc->update = true;
+	return tgc->rc;
 }
 
Index: uspace/lib/gfxfont/include/gfx/font.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/font.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfxfont/include/gfx/font.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -50,4 +50,5 @@
 extern errno_t gfx_font_create(gfx_typeface_t *, gfx_font_props_t *,
     gfx_font_metrics_t *, gfx_font_t **);
+extern errno_t gfx_font_create_textmode(gfx_typeface_t *, gfx_font_t **);
 extern errno_t gfx_font_open(gfx_font_info_t *, gfx_font_t **);
 extern void gfx_font_close(gfx_font_t *);
Index: uspace/lib/gfxfont/include/gfx/text.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/text.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfxfont/include/gfx/text.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,4 +46,12 @@
 extern errno_t gfx_puttext(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
     const char *);
+extern void gfx_text_start_pos(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
+    const char *, gfx_coord2_t *);
+extern size_t gfx_text_find_pos(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
+    const char *, gfx_coord2_t *);
+extern void gfx_text_cont(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
+    const char *, gfx_coord2_t *, gfx_text_fmt_t *);
+extern void gfx_text_rect(gfx_font_t *, gfx_coord2_t *, gfx_text_fmt_t *,
+    const char *, gfx_rect_t *);
 
 #endif
Index: uspace/lib/gfxfont/include/types/gfx/font.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/font.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfxfont/include/types/gfx/font.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -52,5 +52,7 @@
 	gff_italic = 0x2,
 	/** Bold, italic */
-	gff_bold_italic = gff_bold | gff_italic
+	gff_bold_italic = gff_bold | gff_italic,
+	/** Text mode */
+	gff_text_mode = 0x4
 } gfx_font_flags_t;
 
Index: uspace/lib/gfxfont/include/types/gfx/text.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/text.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfxfont/include/types/gfx/text.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -38,4 +38,5 @@
 
 #include <types/gfx/coord.h>
+#include <types/gfx/color.h>
 
 /** Text horizontal alignment */
@@ -65,4 +66,6 @@
 /** Text formatting */
 typedef struct {
+	/** Text color */
+	gfx_color_t *color;
 	/** Horizontal alignment */
 	gfx_halign_t halign;
Index: uspace/lib/gfxfont/src/font.c
===================================================================
--- uspace/lib/gfxfont/src/font.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/gfxfont/src/font.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -180,4 +180,30 @@
 }
 
+/** Create dummy font for printing text in text mode.
+ *
+ * @param tface Typeface
+ * @param rfont Place to store pointer to new font
+ *
+ * @return EOK on success, EINVAL if parameters are invald,
+ *         ENOMEM if insufficient resources, EIO if graphic device connection
+ *         was lost
+ */
+errno_t gfx_font_create_textmode(gfx_typeface_t *tface, gfx_font_t **rfont)
+{
+	gfx_font_props_t props;
+	gfx_font_metrics_t metrics;
+
+	gfx_font_props_init(&props);
+	props.size = 1;
+	props.flags = gff_text_mode;
+
+	gfx_font_metrics_init(&metrics);
+	metrics.ascent = 0;
+	metrics.descent = 0;
+	metrics.leading = 1;
+
+	return gfx_font_create(tface, &props, &metrics, rfont);
+}
+
 /** Open font.
  *
